diff -NaurdbB -xCVS lsqrms-2.0.4b.old/AUTHORS lsqrms-2.0.4b/AUTHORS
--- lsqrms-2.0.4b.old/AUTHORS	Wed Mar 12 17:18:30 EST 2003
+++ lsqrms-2.0.4b/AUTHORS	Mon Feb 25 15:39:52 EST 2008
@@ -0,0 +1,4 @@
+Vadim Alexandrov (initial authorship; http://bioinfo.mbb.yale.edu/~vadim/)
+Julian Graham (April 2003)
+Allen Smith (modified 2003-2007; http://cesario.rutgers.edu/easmith/research/)
+
diff -NaurdbB -xCVS lsqrms-2.0.4b.old/README lsqrms-2.0.4b/README
--- lsqrms-2.0.4b.old/README	Wed Mar 12 17:18:28 EST 2003
+++ lsqrms-2.0.4b/README	Sun Feb 24 22:49:52 EST 2008
@@ -0,0 +1,43 @@
+LSQRMS program. V. Alexandrov, Yale (2000).
+
+The LSQ fitting routine (when the program is called with "lsq" keyword) works 
+as follows. Assuming that the set of equivalence pairs for two structures (we 
+call them "moving" and "reference" structures, respectively) is determined, 
+e.g. found from the corresponding sequence alignment, the structural alignment
+is done in two steps. The first is to find the translation vector (TV) that 
+takes the center-of-mass (CM) of one structure to the other (easy: find CM 
+coordinates for each structure and subtract the CM vector of the "moving" 
+structure from the CM vector of the "fixed" one). The second step is to compute
+the matrix transformation (Rotation Matrix) that minimizes RMSD between the two
+structures after applying TV transformation to the moving structure from the 
+previous step. Note that CM for both structures is calculated based only on
+those C-alphas that are present in the set of equivalence pairs.
+
+After the CM (center-of-mass) of the "moving" structure is first moved to that
+of the "reference" structure (with help of the Translation Vector from the 
+previous step) the rotation matrix (RM) is computed using a wide-known method 
+suggested by Kabsch (1977). The method is based on finding the solution for the
+parameters of the 3D rotation matrix minimizing the RMSD of the CM-transformed
+structures (actually, their equivalence pairs only).
+
+After applying RM to the "moving" structure (preceded by TV translation), the
+RMSD is calculated between the coordinates for all the equivalence pairs.
+If the program is not called with "lsq" argument, it repeats the
+above-mentioned process (skipping the sequence alignment stage at each
+iteration) finding new equivalence pairs and minimizing RMSD in each iteration
+until it converges to some minimum value or until the program reaches the 
+maximum number of iterations (currently 100).
+
+If supplied with keyword "structal", the program outputs the resulting 
+structures (original "target" and rotated "query" structures + the
+corresponding equivalence pairs) in the original Structal format (Levitt, 
+1994). Otherwise, the program outputs only the new (rotated and translated) 
+coordinates of the query.
+
+Refs.
+
+1) Kabsch (Kabsch, W (1976) Acta Cryst. A32, 922-923) 
+2) Levitt, M., STRUCTAL. A structural alignment program, Stanford U, (1994).
+
+
+
diff -NaurdbB -xCVS lsqrms-2.0.4b.old/src/dynapro.c lsqrms-2.0.4b/src/dynapro.c
--- lsqrms-2.0.4b.old/src/dynapro.c	Wed Apr 16 15:07:45 EDT 2003
+++ lsqrms-2.0.4b/src/dynapro.c	Sun Feb 24 22:49:49 EST 2008
@@ -1,49 +1,64 @@
+#include "umath.h"
+#include "matvecalloc.h"
 #include "dynapro.h"
 
-int    *iVector(long, long);
-int   **iMatrix(long, long, long, long);
-void free_iVector(int     *, long, long);
-void free_fMatrix(int    **, long, long, long, long);
+#define MAX_COLS MAXSEQ
+#define MAX_ROWS MAXSEQ
 
-double               /* OUT: maximum score in sum matrix                          */
-/*******/
-dyn_pr_n2
-/*******/
+#define INF_INT 2147480000
+
+#define STOP_TRACEBACK -1
+
 /* Sequence 1 runs down   matrix index by row index i.
    Sequence 2 runs across matrix index by row index j. */
-(double **s        /* IN:  similarity matrix               [0..rows-1][0..cols-1] */, 
- int *iOpnPen      /* IN:  gap-open pen. vector for seq. 1 [0..rows-1]            */, 
- int *iExtPen      /* IN:  gap-extend pen. vec. for seq. 1 [0..rows-1]            */, 
- int *jOpnPen      /* IN:  gap-open pen. vector for seq. 2 [0..cols-1]            */, 
- int *jExtPen      /* IN:  gap-extend pen. vec. for seq. 2 [0..cols-1]            */, 
- int rows          /* IN:  length of sequence 1 (Runs down matrix,  indexed by i) */,
- int cols          /* IN:  length of sequence 2 (Runs across matrix, indexed by j)*/,
- double **SS       /* OUT: sum matrix                      [0..rows-1][0..cols-1] */, 
- double **TrRow    /* OUT: traceback matrix with i index   [0..rows-1][0..cols-1] */, 
- double **TrCol    /* OUT: traceback matrix with j index   [0..rows-1][0..cols-1] */,
- int *iOverallMax  /* OUT: i index where overall max occurs 0..rows-1             */,
- int *jOverallMax  /* OUT: j index where overall max occurs 0..cols-1             */
-)
-{
-  double TrialScore, ColMax, BlkMax, RowMax;
-  int 
-    i,j,i2,j2, jRowMax,
-    iBlkMax, jBlkMax, 
-    iGapLength, jGapLength, iGapPenalty, jGapPenalty;
-  double OverallMax = - INF_INT;
+
+/* OUT: maximum score in sum matrix */
+double dyn_pr_n2
+(
+ /* IN:  similarity matrix [0..rows-1][0..cols-1] */
+ double **s,
+ /* IN:  gap-open pen. vector for seq. 1 [0..rows-1] */
+ int *iOpnPen,
+ /* IN:  gap-extend pen. vec. for seq. 1 [0..rows-1] */
+ double *iExtPen,
+ /* IN:  gap-open pen. vector for seq. 2 [0..cols-1] */
+ int *jOpnPen,
+ /* IN:  gap-extend pen. vec. for seq. 2 [0..cols-1] */
+ double *jExtPen,
+ /* IN:  residue number for seq. 1 [0..rows-1] */
+ int *iresnum,
+ /* IN:  residue number for seq. 2 [0..cols-1] */
+ int *jresnum,
+ /* IN:  length of sequence 1 (Runs down matrix, indexed by i) */
+ int rows,
+ /* IN:  length of sequence 2 (Runs across matrix, indexed by j)*/
+ int cols,
+ /* OUT: sum matrix [0..rows-1][0..cols-1] */
+ double **SS,
+ /* OUT: traceback matrix with i index [0..rows-1][0..cols-1] */
+ double **TrRow,
+ /* OUT: traceback matrix with j index [0..rows-1][0..cols-1] */
+ double **TrCol,
+ /* OUT: i index where overall max occurs 0..rows-1 */
+ int *iOverallMax,
+ /* OUT: j index where overall max occurs 0..cols-1 */
+ int *jOverallMax) {
+  double TrialScore, ColMax, RowMax;
+  int i,j,i2,j2, jRowMax;
+  int iGapLength, jGapLength;
+  double iGapPenalty, jGapPenalty;
+  double OverallMax = -INF_INT;
   int iColMax[MAX_COLS];
-  int Parm_FastBlkMax = 0;
-  int Parm_SlowBlkMax = 0;
   
   for(i=0; i< rows; i++) {
     SS[i][0] = s[i][0];
-    TrRow[i][0] = STOP_TRACEBACK ;
-    TrCol[i][0] = STOP_TRACEBACK ;
+    TrRow[i][0] = STOP_TRACEBACK;
+    TrCol[i][0] = STOP_TRACEBACK;
   }
   for(j=0; j< cols; j++) {
     SS[0][j] = s[0][j];
-    TrRow[0][j] = STOP_TRACEBACK ;
-    TrCol[0][j] = STOP_TRACEBACK ;
+    TrRow[0][j] = STOP_TRACEBACK;
+    TrCol[0][j] = STOP_TRACEBACK;
     iColMax[j] = 0;
   }
   
@@ -50,12 +65,10 @@
   for(i=1; i< rows; i++) {
 
     jRowMax = 0;
-    jBlkMax = 0;
-    iBlkMax = iColMax[0];
     
     for(j=1; j< cols; j++) {
       
-      /* You are at position i,j, consider four
+      /* You are at position i,j, consider three
          possible maximum values: */
       
       /* 1. The value at SS[i-1][j-1] with no gaps */
@@ -62,151 +75,137 @@
 
       /* 2. The maximum on column j-1 up to row i-2. */
 
-      for (ColMax = -INF_INT,i2=iColMax[j-1];
-	   i2<i-1; i2++) {
+      ColMax = -INF_INT;
+      if (iresnum[i-1] != iresnum[i]) { /* No gaps inside residues! - Allen */
+	for (i2=iColMax[j-1]; i2<i-1; i2++) {
+	  if ((iresnum[i2] != iresnum[i2+1]) &&
+	      ((SS[i-1][j-1] <= 0) || (s[i-1][j-1] < 0) || (i2 == 0) ||
+	       (j == (cols-1)) || (TrCol[i2][j-1] == j-2) ||
+	       (TrCol[i2][j-1] == STOP_TRACEBACK))) { /* XXX */
 	iGapLength = i - i2 - 1;
-	iGapPenalty = iOpnPen[i] + (iGapLength - 1) * iExtPen[i];
-	TrialScore = SS[i2][j-1] - iGapPenalty ;
+	    iGapPenalty = /* XXX */
+	      MIN(iOpnPen[i],iOpnPen[i2]) +
+	      ((iGapLength - 1) * MIN(iExtPen[i],iExtPen[i2]));
+	    TrialScore = SS[i2][j-1] - iGapPenalty;
 	if (TrialScore >= ColMax) {
-	  iColMax[j-1] = i2 ;
-	  ColMax = TrialScore ;
+	      iColMax[j-1] = i2;
+	      ColMax = TrialScore;
+	    }
 	}
       }
+      }
       
       /* 3. The maximum on row i-1 up to column j-2. */
 
-      RowMax = -INF_INT ;
+      RowMax = -INF_INT;
+      if (jresnum[j-1] != jresnum[j]) {
       for (j2=jRowMax; j2<j-1; j2++) {
+	  if ((jresnum[j2] != jresnum[j2+1]) &&
+	      ((SS[i-1][j-1] <= 0) || (s[i-1][j-1] < 0) || (j2 == 0) ||
+	       (i == (rows-1)) || (TrRow[i-1][j2] == i-2) ||
+	       (TrRow[i-1][j2] == STOP_TRACEBACK))) { /* XXX */
 	jGapLength = j - j2 - 1;
-	jGapPenalty = jOpnPen[j] + (jGapLength - 1) * jExtPen[j];
-	TrialScore = SS[i-1][j2] - jGapPenalty ;
+	    jGapPenalty = /* XXX */
+	      MIN(jOpnPen[j],jOpnPen[j2]) +
+	      ((jGapLength - 1) * MIN(jExtPen[j],jExtPen[j2]));
+	    TrialScore = SS[i-1][j2] - jGapPenalty;
 	if (TrialScore >= RowMax) {
-	  jRowMax = j2 ;
-	  RowMax = TrialScore ;
-	}
-      }
-      
-      /* 4. The maximum in block 
-	 with bottom right-hand corner at (i-2,j-1) 
-	 and top left-hand corner at (iBlkMax, jBlkMax). */
- 
-      if (Parm_SlowBlkMax) {
-
-	BlkMax = -INF_INT ;
-	for (i2=iBlkMax; i2 < i-1; i2++) {
-	  for (j2=jBlkMax; j2 < j-1; j2++) {
-	    jGapLength = j - j2 - 1;
-	    jGapPenalty = jOpnPen[j] + (jGapLength - 1) * jExtPen[j];
-	    iGapLength = i - i2 - 1;
-	    iGapPenalty = iOpnPen[i] + (iGapLength - 1) * iExtPen[i];
-	    TrialScore = SS[i2][j2] - iGapPenalty - jGapPenalty;
-	    if (TrialScore >= BlkMax) {
-	      jBlkMax = j2 ;
-	      iBlkMax = i2 ;
-	      BlkMax = TrialScore ;
-	    }
-	  }
-	}
-	
-      } else if (Parm_FastBlkMax) {
-	
-	BlkMax = -INF_INT ;
-	for (j2=jBlkMax; j2 < j-1; j2++) {
-	  i2 = iColMax[j2];
-	  if (i2 < i - 1) {
-	    jGapLength = j - j2 - 1;
-	    jGapPenalty = jOpnPen[j] + (jGapLength - 1) * jExtPen[j];
-	    iGapLength = i - i2 - 1;
-	    iGapPenalty = iOpnPen[i] + (iGapLength - 1) * iExtPen[i];
-	    TrialScore = SS[i2][j2] - iGapPenalty - jGapPenalty;
-	    if (TrialScore >= BlkMax) {
-	      jBlkMax = j2 ;
-	      iBlkMax = i2 ;
-	      BlkMax = TrialScore ;
+	      jRowMax = j2;
+	      RowMax = TrialScore;
 	    }
 	  }
 	}
-	
-      } else {
-	jBlkMax = j2 ;
-	iBlkMax = i2 ;
-	BlkMax = -INF_INT ;
       }
 	
-      
       if /* Case 1 */ 
 	(SS[i-1][j-1] >= ColMax &&
-	 SS[i-1][j-1] >= RowMax &&
-	 SS[i-1][j-1] >= BlkMax) {
-	  TrRow[i][j] =  i-1 ;
+	 SS[i-1][j-1] >= RowMax) {
+	  TrRow[i][j] =  i-1;
 	  TrCol[i][j] =  j-1;
-	  SS[i][j] = s[i][j] + SS[i-1][j-1] ;
+	  SS[i][j] = s[i][j] + SS[i-1][j-1];
       } else if /* Case 2 */
 	(/* ColMax >= SS[i-1][j-1] .. True anyway! */
-	 ColMax >= RowMax &&
-	 ColMax >= BlkMax) {
-	  TrRow[i][j] =  iColMax[j-1] ;
+	 ColMax > RowMax) {
+	  TrRow[i][j] =  iColMax[j-1];
 	  TrCol[i][j] =  j-1;
-	  SS[i][j] = s[i][j] + ColMax ;
-      } else if /* Case 3 */
-	(/* RowMax >= SS[i-1][j-1]  ..True anyway! */
-	 /* RowMax >= ColMax        ..True anyway! */
-	 RowMax >= BlkMax) {
+	  SS[i][j] = s[i][j] + ColMax;
+      } else if (RowMax > ColMax) { /* Case 3 */
+	/* RowMax >= SS[i-1][j-1]  ..True anyway! */
 	  TrRow[i][j] =  i-1;
-	  TrCol[i][j] =  jRowMax ;
-	  SS[i][j] = s[i][j] + RowMax ;
-      } else if /* Case 4 */
-	(BlkMax >= SS[i-1][j-1] && /*True anyway! */
-	 BlkMax >= ColMax &&       /*True anyway! */
-	 BlkMax >= RowMax) {       /*True anyway! */
-	  TrRow[i][j] =  iBlkMax;
-	  TrCol[i][j] =  jRowMax ;
-	  SS[i][j] = s[i][j] + BlkMax ;
+	TrCol[i][j] =  jRowMax;
+	SS[i][j] = s[i][j] + RowMax;
+      } else { /* Tied ColMax, RowMax */
+	if (rows > cols) {
+	  TrRow[i][j] =  iColMax[j-1];
+	  TrCol[i][j] =  j-1;
+	  SS[i][j] = s[i][j] + ColMax;
+	} else if (cols > rows) {
+	  TrRow[i][j] =  i-1;
+	  TrCol[i][j] =  jRowMax;
+	  SS[i][j] = s[i][j] + RowMax;
       } else {
-	printf("Error somehow not in case 1 to 4.\n");
+	  iGapLength = i - iColMax[j-1] - 1;
+	  jGapLength = j - jRowMax - 1;
+	  if (jGapLength >= iGapLength) {
+	    TrRow[i][j] =  iColMax[j-1];
+	    TrCol[i][j] =  j-1;
+	    SS[i][j] = s[i][j] + ColMax;
+	  } else {
+	    TrRow[i][j] =  i-1;
+	    TrCol[i][j] =  jRowMax;
+	    SS[i][j] = s[i][j] + RowMax;
       }
+	}
+      }
       
-      if (SS[i][j] > OverallMax) {
+      if (((i == (rows-1)) || (j == (cols-1))) && /* global alignment */
+	  (SS[i][j] >= OverallMax)) {
 	OverallMax = SS[i][j];
-	*iOverallMax = i ;
-	*jOverallMax = j ;
+	*iOverallMax = i;
+	*jOverallMax = j;
       }
     } /* j-loop */
   } /* i-loop */
-  return OverallMax ;
+  return OverallMax;
 }
 
-int                /* OUT: number of equivalenced residues = n                       */
-/*--------------*/
-TrMat2Equivalences 
-/*--------------*/
+/* OUT: number of equivalenced residues = n */
+int TrMat2Equivalences 
 (
- int rows          /* IN:  length of sequence 1                                      */,
- int cols          /* IN:  length of sequence 2                                      */,
- double **TrRow    /* IN:  traceback matrix with row index   [0..rows-1][0..cols-1]  */, 
- double **TrCol    /* IN:  traceback matrix with col index   [0..rows-1][0..cols-1]  */,
- int iOverallMax   /* IN:  row index where overall max occurs 0..rows-1              */,
- int jOverallMax   /* IN:  col index where overall max occurs 0..cols-1              */,
- int *equiv1       /* OUT: seq. 1 equivalenced residues, using fortran conv. [0..n-1]*/,
- int *equiv2       /* OUT: seq. 2 equivalenced residues, using fortran conv. [0..n-1]*/,
- int *nbrks        /* OUT: number of chain breaks                                    */
-)
-{
+ /* IN:  length of sequence 1 */
+ int rows,
+ /* IN:  length of sequence 2 */
+ int cols,
+ /* IN:  traceback matrix with row index [0..rows-1][0..cols-1] */
+ double **TrRow,
+ /* IN:  traceback matrix with col index [0..rows-1][0..cols-1] */
+ double **TrCol,
+ /* IN:  row index where overall max occurs 0..rows-1 */
+ int iOverallMax,
+ /* IN:  col index where overall max occurs 0..cols-1 */
+ int jOverallMax,
+ /* OUT: seq. 1 equivalenced residues, using fortran conv. [0..n-1] */
+ int *equiv1,
+ /* OUT: seq. 2 equivalenced residues, using fortran conv. [0..n-1] */
+ int *equiv2,
+ /* OUT: number of chain breaks */
+ int *nbrks){
   int ReversedEquiv1[MAX_ROWS];
   int ReversedEquiv2[MAX_COLS];
   int n = 0; 
-  int i = iOverallMax ;
-  int j = jOverallMax ;
-  int ii, jj,nn;
+  int i = iOverallMax;
+  int j = jOverallMax;
+  int ii,jj,nn;
   do {
-    ReversedEquiv1[n] = i ;
-    ReversedEquiv2[n] = j ;
-    n++ ;
-    ii = (int)TrRow[i][j] ;
-    jj = (int)TrCol[i][j] ;
+    ii = (int)TrRow[i][j];
+    jj = (int)TrCol[i][j];
+
+    ReversedEquiv1[n] = i;
+    ReversedEquiv2[n] = j;
+    n++;
     if (ii != STOP_TRACEBACK && 
 	!(ii == i - 1 && jj == j - 1)) {
-      *nbrks = *nbrks + 1 ;
+      *nbrks = *nbrks + 1;
     }
     i = ii; j = jj;
   } while (i != STOP_TRACEBACK);
@@ -217,5 +216,5 @@
     equiv2[i] = ReversedEquiv2[nn-1] + 1; 
   }
 
-  return n ;
+  return i;
 }
diff -NaurdbB -xCVS lsqrms-2.0.4b.old/src/dynapro.h lsqrms-2.0.4b/src/dynapro.h
--- lsqrms-2.0.4b.old/src/dynapro.h	Wed Mar 12 17:12:03 EST 2003
+++ lsqrms-2.0.4b/src/dynapro.h	Sun Feb 24 22:49:49 EST 2008
@@ -1,11 +1,6 @@
-# include <stdio.h>
-
-#define MAX_COLS 1000
-#define MAX_ROWS 1000
-
-#define INF_INT 2147480000
-
-extern int Parm_SlowBlkMax ;
-extern int Parm_FastBlkMax ;
+#include <stdio.h>
 
-#define STOP_TRACEBACK -1
+double dyn_pr_n2(double **, int *, double *, int *, double *, int *, int *,
+		 int, int, double **, double **, double **, int *, int *);
+int TrMat2Equivalences(int, int, double **, double **, int, int,
+		       int *, int *, int *);
diff -NaurdbB -xCVS lsqrms-2.0.4b.old/src/lsqrms.h lsqrms-2.0.4b/src/lsqrms.h
--- lsqrms-2.0.4b.old/src/lsqrms.h
+++ lsqrms-2.0.4b/src/lsqrms.h	Sun Feb 24 22:49:49 EST 2008
@@ -0,0 +1,53 @@
+#ifndef LSQRMS_H
+#define LSQRMS_H
+
+#define MAXSEQ 4000
+
+#ifdef HAVE_CONFIG_H
+#include "../config.h"
+#endif
+
+#ifdef __sgi
+# include <sgidefs.h>
+#endif
+
+#include <stdio.h>
+/* will probably want to make below conditional */
+#include <errno.h>
+
+#if STDC_HEADERS
+# include <stdlib.h>
+# include <stddef.h>
+# include <string.h>
+#else
+# if HAVE_STDLIB_H
+#  include <stdlib.h>
+# endif
+# if HAVE_STRING_H
+#  include <string.h>
+# else
+#  if HAVE_STRINGS_H
+#   include <strings.h>
+#  endif
+# endif
+#endif
+
+#if HAVE_UNISTD_H
+# include <unistd.h>
+#endif
+
+#if HAVE_SYS_TYPES_H
+# include <sys/types.h>
+#endif
+
+#if (!HAVE_SYS_TYPES_H || (!defined(__sgi)))
+# if HAVE_INTTYPES_H
+#  include <inttypes.h>
+# else
+#  if HAVE_STDINT_H
+#   include <stdint.h>
+#  endif
+# endif
+#endif
+
+#endif /* LSQRMS_H */
